#region Copyright(c) Anton Shelin, Vladimir Timashkov. All Rights Reserved.
// -----------------------------------------------------------------------------
// Copyright(c) 2010 Anton Shelin, Vladimir Timashkov. All Rights Reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
//   1. No Trademark License - Microsoft Public License (Ms-PL) does not grant you rights to use
//      authors names, logos, or trademarks.
//   2. If you distribute any portion of the software, you must retain all copyright,
//      patent, trademark, and attribution notices that are present in the software.
//   3. If you distribute any portion of the software in source code form, you may do
//      so only under this license by including a complete copy of Microsoft Public License (Ms-PL)
//      with your distribution. If you distribute any portion of the software in compiled
//      or object code form, you may only do so under a license that complies with
//      Microsoft Public License (Ms-PL).
//   4. The names of the authors may not be used to endorse or promote products
//      derived from this software without specific prior written permission.
//
// The software is licensed "as-is." You bear the risk of using it. The authors
// give no express warranties, guarantees or conditions. You may have additional consumer
// rights under your local laws which this license cannot change. To the extent permitted
// under your local laws, the authors exclude the implied warranties of merchantability,
// fitness for a particular purpose and non-infringement.
// -----------------------------------------------------------------------------
#endregion

namespace SharpDom.Navigation
{
    /// <summary>Interface summing up marker interfaces of all tags
    /// allowing the inheritant to be a child of any tag</summary>
    public interface IFullAdoptability :
        ITagTitleChild,
        ITagBaseChild,
        ITagMetaChild,
        ITagLinkChild,
        ITagStyleChild,
        ITagScriptChild,
        ITagNoScriptChild,
        ITagBodyChild,
        ITagDivChild,
        ITagPChild,
        ITagH1Child,
        ITagH2Child,
        ITagH3Child,
        ITagH4Child,
        ITagH5Child,
        ITagH6Child,
        ITagLiChild,
        ITagDtChild,
        ITagDdChild,
        ITagAddressChild,
        ITagHrChild,
        ITagPreChild,
        ITagBlockQuoteChild,
        ITagInsChild,
        ITagDelChild,
        ITagAChild,
        ITagSpanChild,
        ITagBdoChild,
        ITagBrChild,
        ITagEmChild,
        ITagStrongChild,
        ITagDfnChild,
        ITagCodeChild,
        ITagSampChild,
        ITagKbdChild,
        ITagVarChild,
        ITagCiteChild,
        ITagAbbrChild,
        ITagAcronymChild,
        ITagQChild,
        ITagSubChild,
        ITagSupChild,
        ITagTtChild,
        ITagIChild,
        ITagBChild,
        ITagBigChild,
        ITagSmallChild,
        ITagParamChild,
        ITagImgChild,
        ITagAreaChild,
        ITagFormChild,
        ITagLabelChild,
        ITagInputChild,
        ITagOptionChild,
        ITagTextAreaChild,
        ITagLegendChild,
        ITagButtonChild,
        ITagCaptionChild,
        ITagColChild,
        ITagThChild,
        ITagTdChild
    {
    }
}
